#include "core/utils/Error.hpp"

#define CASE_RETURN_ENUM_NAME(type)                                            \
    case Error::type: return #type

const char* Core::getErrorName(Error e) {
    switch(e) {
        CASE_RETURN_ENUM_NAME(NONE);
        CASE_RETURN_ENUM_NAME(NEGATIVE_ARGUMENT);
        CASE_RETURN_ENUM_NAME(CAPACITY_REACHED);
        CASE_RETURN_ENUM_NAME(BLOCKED_STDOUT);
        CASE_RETURN_ENUM_NAME(OUT_OF_MEMORY);
        CASE_RETURN_ENUM_NAME(INVALID_CHAR);
        CASE_RETURN_ENUM_NAME(NOT_FOUND);
        CASE_RETURN_ENUM_NAME(INVALID_STATE);
        CASE_RETURN_ENUM_NAME(INVALID_INDEX);
        CASE_RETURN_ENUM_NAME(INVALID_ARGUMENT);
        CASE_RETURN_ENUM_NAME(TIME_NOT_AVAILABLE);
        CASE_RETURN_ENUM_NAME(SLEEP_INTERRUPTED);
        CASE_RETURN_ENUM_NAME(THREAD_ERROR);
        CASE_RETURN_ENUM_NAME(MUTEX_ERROR);
        CASE_RETURN_ENUM_NAME(EXISTING_KEY);
        CASE_RETURN_ENUM_NAME(CANNOT_OPEN_FILE);
        CASE_RETURN_ENUM_NAME(END_OF_FILE);
    }
    return "?";
}